#include <16F628A.h>
#include <string.h>
#include <stdlib.h>
#FUSES NOWDT                      //Watch Dog Timer
#FUSES HS                       //Crystal osc <= 4mhz
#FUSES NOPUT                    //No Power Up Timer
#FUSES NOPROTECT                //Code not protected from reading
#FUSES NOBROWNOUT               //No brownout reset
#FUSES MCLR                     //Master Clear pin enabled
#FUSES NOLVP                    //No low voltage prgming, B3(PIC16) or B5(PIC18) used for I/O
#FUSES NOCPD                    //No EE protection
#use delay(clock=4000000)
#use rs232(baud=19200,parity=N, xmit=PIN_B2, rcv=PIN_B1, bits=8, stream=AT_Com)

#define BUFFER_SIZE 50
BYTE buffer[BUFFER_SIZE];
BYTE next_in = 0;
BYTE next_out = 50;

const char SMS[]="at+cmss=", i1[]="ate0\r", i2[]="AT+CNMI=1,1,0,0,1\r", i3[]="at+cpbs=\"SM\"\r";
unsigned char bit=true, bit1=true, bit3=false, start=true; 
unsigned int  n=0; 
Char N1[11],N2[11],mask[12]; //   ;



#int_rda
void serial_isr() {
   int t;
   buffer[next_in]=getc();
   t=next_in;
   if(!iscntrl(buffer[next_in])&& !isspace(buffer[next_in])) next_in=(next_in+1) % BUFFER_SIZE;
   if(next_in==next_out)  next_in=0;   // Buffer full !!
}

Void call()
{  
   strcpy(Mask,"NO CARRIER");  strcpy(buffer,"");
   printf("atd+7%S;\r",N1); delay_ms(48000);
   Output_a(0x02);
if (strstr(buffer, Mask)!=null)  {
      printf("atd+7%s;\r",N2); delay_ms(48000);  
      if (strstr(buffer, Mask)!=null)printf("%s4\r",SMS); delay_ms(360000); }    
 delay_ms(4000); 
}

void main()
{
   enable_interrupts(global);
   enable_interrupts(int_rda);
   port_b_pullups(TRUE); set_tris_b(0xFF);
   set_tris_A(0x00); output_A(0x02);
   printf("%s",i1); delay_ms(800);
   printf("%s",i2); delay_ms(800);
   printf("%s",i3);
   delay_ms(400); 
   printf("%d",bit3); 
    
  //  2     
   next_in=0;
   printf("at+cpbr=1\r");  delay_ms(2000);   // 
   for (n=0; n<=9; n++)  N1[n] = buffer[n+11]; N1[10] = 0 ; // EOS
   next_in=0;
   printf("at+cpbr=2\r"); delay_ms(2000);
   for (n=0; n<=9; n++)   N2[n] = Buffer[n+11]; N2[10] = 0 ; // EOS 
   next_in=0;
   while (1) {
     //     
     strcpy(Mask,"+CMTI:"); 
     if (strstr(buffer, Mask)!=null)   //      
        {  
         next_in=0;
         printf("at+CMGR=5\r"); //     
         strcpy(Mask,"stop");  delay_ms(8000); 
         if (strstr(buffer,Mask)!=null) start=false;        //     stop
         strcpy(Mask,"start"); 
         if (strstr(buffer,Mask)!=null) start=true;        
          printf("AT+CMGD=5\r");
        }
     //  
    If (start)
        {
         delay_ms(1200); 
         if (!input(pin_B3) & bit) {printf("%s1\r",SMS); bit=False;}
         if ( input(pin_B3)& !bit) {printf("%s2\r",SMS); bit=True; }
         delay_ms(100);  
         if (input(pin_B4)& bit1) {printf("%s3\r",SMS); bit1=False;}
         if (!input(pin_B4)& !bit1) bit1=True;
         output_high(Pin_A2);
         delay_ms(100); 
         if (input(pin_B5)){output_A(0x01); Call();}
         output_low(Pin_A2); output_high(Pin_A3);
         delay_ms(100); 
         if (input(pin_B6)){output_A(0x01); Call();}
         output_low(Pin_A3); output_high(Pin_A4);
         delay_ms(100);
         if (input(pin_B7)){output_A(0x01); Call();}
         output_low(Pin_A4);
        }  
}
}
